import { CdkFooterRow, CdkFooterRowDef, CdkHeaderRow, CdkHeaderRowDef, CdkRow, CdkRowDef } from "@angular/cdk/table";
import { AfterViewInit, ChangeDetectorRef, ElementRef, IterableDiffers, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef } from "@angular/core";
import { Subscription } from "rxjs";
import { ISelectorState } from "../../../services/public-api";
import { SelectionType } from "../../selector/public-api";
import { TableStateHandlerService } from "../table-state-handler.service";
import { ClickableRowOptions, RowHeightOptions } from "../types";
import * as i0 from "@angular/core";
/**
 * @ignore
 */
export declare class TableHeaderRowDefDirective extends CdkHeaderRowDef implements OnInit, OnDestroy, OnChanges {
    private tableStateHandlerService;
    set nuiHeaderRowDef(value: any);
    set nuiHeaderRowDefSticky(value: boolean);
    tableColumnsSubscription: Subscription;
    constructor(template: TemplateRef<any>, _differs: IterableDiffers, tableStateHandlerService: TableStateHandlerService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableHeaderRowDefDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TableHeaderRowDefDirective, "[nuiHeaderRowDef]", never, { "nuiHeaderRowDef": "nuiHeaderRowDef"; "nuiHeaderRowDefSticky": "nuiHeaderRowDefSticky"; }, {}, never>;
}
/**
 * @ignore
 */
export declare class TableRowDefDirective<T> extends CdkRowDef<T> implements OnInit, OnDestroy {
    private tableStateHandlerService;
    set nuiRowDefColumns(value: any);
    set nuiRowDefWhen(value: (index: number, rowData: T) => boolean);
    tableColumnsSubscription: Subscription;
    constructor(template: TemplateRef<any>, _differs: IterableDiffers, tableStateHandlerService: TableStateHandlerService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableRowDefDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TableRowDefDirective<any>, "[nuiRowDef]", never, { "nuiRowDefColumns": "nuiRowDefColumns"; "nuiRowDefWhen": "nuiRowDefWhen"; }, {}, never>;
}
/**
 * @ignore
 */
export declare class TableFooterRowDefDirective extends CdkFooterRowDef implements OnInit, OnDestroy {
    private tableStateHandlerService;
    set nuiFooterRowDef(value: any);
    set nuiFooterRowDefSticky(value: boolean);
    tableColumnsSubscription: Subscription;
    constructor(template: TemplateRef<any>, _differs: IterableDiffers, tableStateHandlerService: TableStateHandlerService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableFooterRowDefDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TableFooterRowDefDirective, "[nuiFooterRowDef]", never, { "nuiFooterRowDef": "nuiFooterRowDef"; "nuiFooterRowDefSticky": "nuiFooterRowDefSticky"; }, {}, never>;
}
/**
 * @ignore
 */
export declare class TableHeaderRowComponent extends CdkHeaderRow implements OnInit, OnDestroy, AfterViewInit {
    private tableStateHandlerService;
    private changeDetectorRef;
    density: RowHeightOptions;
    selectorState: ISelectorState;
    selectable: boolean;
    selectionChangeSubscription: Subscription;
    dataSourceChangeSubscription: Subscription;
    get isDensityDefault(): boolean;
    get isDensityCompact(): boolean;
    get isDensityTiny(): boolean;
    get hasOptions(): boolean;
    private onDestroy$;
    constructor(tableStateHandlerService: TableStateHandlerService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    onSelectorChange(selectorValue: SelectionType): void;
    updateSelectorState(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableHeaderRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableHeaderRowComponent, "nui-header-row, tr[nui-header-row]", ["nuiHeaderRow"], { "density": "density"; }, {}, never, never>;
}
/**
 * @ignore
 */
/** Data row template container that contains the cell outlet. Adds the right class and role. */
export declare class TableRowComponent extends CdkRow implements OnInit, OnDestroy {
    private elementRef;
    private tableStateHandlerService;
    private changeDetectorRef;
    density: RowHeightOptions;
    rowObject: Object;
    clickableRow: boolean;
    clickableRowConfig: ClickableRowOptions;
    selectable: boolean;
    selectionChangeSubscription: Subscription;
    get isSelected(): boolean;
    get isDensityDefault(): boolean;
    get isDensityCompact(): boolean;
    get isDensityTiny(): boolean;
    private rowSelectionCheckbox;
    private onDestroy$;
    constructor(elementRef: ElementRef, tableStateHandlerService: TableStateHandlerService, changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): void;
    rowClickHandler(target: HTMLElement): void;
    checkboxClicked(): void;
    /**
     * We need to stop propagation of the checkbox click to prevent the row click handler from invoking the checkbox toggle functionality again
     */
    stopPropagation(event: Event): void;
    isRowSelected(): boolean;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableRowComponent, "nui-row, tr[nui-row]", ["nuiRow"], { "density": "density"; "rowObject": "rowObject"; "clickableRow": "clickableRow"; "clickableRowConfig": "clickableRowConfig"; }, {}, never, never>;
}
/**
 * @ignore
 */
export declare class TableFooterRowComponent extends CdkFooterRow {
    static ɵfac: i0.ɵɵFactoryDeclaration<TableFooterRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableFooterRowComponent, "nui-footer-row, tr[nui-footer-row]", ["nuiFooterRow"], {}, {}, never, never>;
}
